Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
SceneGraphAnalyzerMeter Class Reference

This is a special TextNode that automatically updates itself with output from a SceneGraphAnalyzer instance. More...

`#include "sceneGraphAnalyzerMeter.h"`

Inheritance diagram for SceneGraphAnalyzerMeter:

## Public Member Functions
| SceneGraphAnalyzerMeter (const std::string &name, PandaNode *node)
void | clear_window ()
| Undoes the effect of a previous call to setup_window().
virtual TypeHandle | force_init_type ()
DisplayRegion * | get_display_region () const
| Returns the DisplayRegion that the meter has created to render itself into the window to setup_window(), or NULL if setup_window() has not been called.
PandaNode * | get_node () const
| Returns the node to be analyzed.
virtual TypeHandle | get_type () const
double | get_update_interval () const
| Returns the number of seconds that will elapse between updates to the frame rate indication.
GraphicsOutput * | get_window () const
| Returns the GraphicsOutput that was passed to setup_window(), or NULL if setup_window() has not been called.
void | set_node (PandaNode *node)
| Sets the node to be analyzed.
void | set_update_interval (double update_interval)
| Specifies the number of seconds that should elapse between updates to the meter.
void | setup_window (GraphicsOutput *window)
| Sets up the frame rate meter to create a DisplayRegion to render itself into the indicated window.
void | update ()
| You can call this to explicitly force the SceneGraphAnalyzerMeter to update itself with the latest scene graph analysis information.
Public Member Functions inherited from TextNode
| TextNode (const std::string &name)
| TextNode (const std::string &name, const TextProperties &copy)
| It's sort of a copy constructor: it copies the indicated TextProperties, without copying a complete TextNode.
virtual void | apply_attribs_to_vertices (const AccumulatedAttribs &attribs, int attrib_types, GeomTransformer &transformer)
| Applies whatever attributes are specified in the AccumulatedAttribs object (and by the attrib_types bitmask) to the vertices on this node, if appropriate.
PN_stdfloat | calc_width (const std::string &line) const
| Returns the width of a line of text of arbitrary characters.
PN_stdfloat | calc_width (const std::wstring &line) const
| Returns the width of a line of text of arbitrary characters.
PN_stdfloat | calc_width (wchar_t character) const
| Returns the width of a single character of the font, or 0.0 if the character is not known.
void | clear_align ()
void | clear_bin ()
void | clear_card ()
| Specifies that a card will not be drawn behind the text.
void | clear_card_border ()
void | clear_card_texture ()
void | clear_draw_order ()
void | clear_font ()
void | clear_frame ()
| Specifies that a border will not be drawn around the text.
void | clear_glyph_scale ()
void | clear_glyph_shift ()
void | clear_indent ()
void | clear_max_rows ()
| Resets the TextNode's default behavior of not limiting the number of rows of text.
void | clear_shadow ()
void | clear_shadow_color ()
void | clear_slant ()
void | clear_small_caps ()
void | clear_small_caps_scale ()
void | clear_tab_width ()
void | clear_text_color ()
void | clear_wordwrap ()
virtual void | compute_internal_bounds (CPT(BoundingVolume) &internal_bounds, int &internal_vertices, int pipeline_stage, Thread *current_thread) const
| Called when needed to recompute the node's _internal_bound object.
virtual | CPT (TransformState) calc_tight_bounds(LPoint3 &min_point
void | force_update ()
| Forces the TextNode to recompute itself now, even if it believes nothing has changed.
PN_stdfloat | get_bottom () const
| Returns the bottommost extent of the text in local 2-d coordinates, unmodified by the set_transform() matrix.
LVecBase4 | get_card_actual () const
| Returns the actual dimensions of the card around the text.
LVecBase4 | get_card_as_set () const
| Returns the dimensions of the card as set by set_card_as_margin() or set_card_actual().
PN_stdfloat | get_card_border_size () const
PN_stdfloat | get_card_border_uv_portion () const
LColor | get_card_color () const
bool | get_card_decal () const
| Returns the card_decal flag.
Texture * | get_card_texture () const
LVecBase4 | get_card_transformed () const
| Returns the actual card dimensions, transformed by the matrix set by set_transform().
CoordinateSystem | get_coordinate_system () const
int | get_flatten_flags () const
LVecBase4 | get_frame_actual () const
| Returns the actual dimensions of the frame around the text.
LVecBase4 | get_frame_as_set () const
| Returns the dimensions of the frame as set by set_frame_as_margin() or set_frame_actual().
LColor | get_frame_color () const
bool | get_frame_corners () const
PN_stdfloat | get_frame_line_width () const
PN_stdfloat | get_height () const
| Returns the net height of the text in local 2-d coordinates.
PN_stdfloat | get_left () const
| Returns the leftmost extent of the text in local 2-d coordinates, unmodified by the set_transform() matrix.
PN_stdfloat | get_line_height () const
| Returns the number of units high each line of text is.
LPoint3 | get_lower_right_3d () const
| Returns the lower-right extent of the text object, after it has been transformed into 3-d space by applying the set_transform() matrix.
int | get_max_rows () const
int | get_num_rows () const
| Returns the number of rows of text that were generated.
PN_stdfloat | get_right () const
| Returns the rightmost extent of the text in local 2-d coordinates, unmodified by the set_transform() matrix.
PN_stdfloat | get_top () const
| Returns the topmost extent of the text in local 2-d coordinates, unmodified by the set_transform() matrix.
LMatrix4 | get_transform () const
virtual int | get_unsafe_to_apply_attribs () const
| Returns the union of all attributes from SceneGraphReducer::AttribTypes that may not safely be applied to the vertices of this node.
LPoint3 | get_upper_left_3d () const
| Returns the upper-left extent of the text object, after it has been transformed into 3-d space by applying the set_transform() matrix.
Geom::UsageHint | get_usage_hint () const
PN_stdfloat | get_width () const
| Returns the net width of the text in local 2-d coordinates.
std::string | get_wordwrapped_text () const
| Returns a string that represents the contents of the text, as it has been formatted by wordwrap rules.
std::wstring | get_wordwrapped_wtext () const
| Returns a wstring that represents the contents of the text, as it has been formatted by wordwrap rules.
bool | has_card () const
bool | has_card_border () const
bool | has_card_texture () const
bool | has_character (wchar_t character) const
| Returns true if the named character exists in the font or can be synthesized by Panda, false otherwise.
bool | has_exact_character (wchar_t character) const
| Returns true if the named character exists in the font exactly as named, false otherwise.
bool | has_frame () const
bool | has_max_rows () const
| Returns true if a limit on the height of the TextNode has been set via set_max_rows(), false otherwise.
bool | has_overflow () const
| Returns true if the last text set on the text node exceeded the max_rows constraint, or false if it all fit.
bool | is_card_as_margin () const
| If this is true, the card was set via a call to set_card_as_margin(), and the dimension of the card as returned by get_card_as_set() represent a margin all around the text.
bool | is_frame_as_margin () const
| If this is true, the frame was set via a call to set_frame_as_margin(), and the dimension of the frame as returned by get_frame_as_set() represent a margin all around the text.
virtual bool | is_renderable () const
| Returns true if there is some value to visiting this particular node during the cull traversal for any camera, false otherwise.
bool | is_whitespace (wchar_t character) const
| Returns true if the indicated character represents whitespace in the font, or false if anything visible will be rendered for it.
virtual void | output (std::ostream &out) const
| PT (PandaNode) generate()
| PT (PandaNode) get_internal_geom() const
virtual void | r_prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state, GeomTransformer &transformer, Thread *current_thread)
| The recursive implementation of prepare_scene().
void | set_align (Alignment align_type)
void | set_bin (const std::string &bin)
void | set_card_actual (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Similar to set_card_as_margin, except the card is specified in actual coordinate units (relative to the text's origin), irrespective of the size of the text.
void | set_card_as_margin (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Specifies that a (possibly opaque or semitransparent) card will be held behind the text when it is next created.
void | set_card_border (PN_stdfloat size, PN_stdfloat uv_portion)
void | set_card_color (const LColor &card_color)
void | set_card_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_card_decal (bool card_decal)
| Sets the card_decal flag.
void | set_card_texture (Texture *card_texture)
void | set_coordinate_system (CoordinateSystem cs)
int | set_draw_order (int draw_order)
void | set_flatten_flags (int flatten_flags)
void | set_font (TextFont *font)
void | set_frame_actual (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Similar to set_frame_as_margin, except the frame is specified in actual coordinate units (relative to the text's origin), irrespective of the size of the text.
void | set_frame_as_margin (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Specifies that a border will be drawn around the text when it is next created.
void | set_frame_color (const LColor &frame_color)
void | set_frame_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_frame_corners (bool corners)
void | set_frame_line_width (PN_stdfloat line_width)
void | set_glyph_scale (PN_stdfloat glyph_scale)
void | set_glyph_shift (PN_stdfloat glyph_shift)
void | set_indent (PN_stdfloat indent)
void | set_max_rows (int max_rows)
void | set_shadow (const LVecBase2 &shadow_offset)
void | set_shadow (PN_stdfloat xoffset, PN_stdfloat yoffset)
void | set_shadow_color (const LColor &shadow_color)
void | set_shadow_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_slant (PN_stdfloat slant)
void | set_small_caps (bool small_caps)
void | set_small_caps_scale (PN_stdfloat small_caps_scale)
void | set_tab_width (PN_stdfloat tab_width)
void | set_text_color (const LColor &text_color)
void | set_text_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_transform (const LMatrix4 &transform)
void | set_usage_hint (Geom::UsageHint usage_hint)
void | set_wordwrap (PN_stdfloat wordwrap)
virtual void | text_changed () final
| Given that we have just read an ampersand from the StringDecoder, and that we have expand_amp in effect and are therefore expected to expand the sequence that this ampersand begins into a single unicode character, do the expansion and return the character.
void | update ()
| Can be called after the TextNode has been fully configured, to force the node to recompute its text immediately, rather than waiting for it to be drawn.
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from PandaNode
| PandaNode (const std::string &name)
void | add_child (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node.
virtual void | add_for_draw (CullTraverser *trav, CullTraverserData &data)
| Adds the node's contents to the CullResult we are building up during the cull traversal, so that it will be drawn at render time.
void | add_stashed (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node, directly as a stashed child.
void | adjust_draw_mask (DrawMask show_mask, DrawMask hide_mask, DrawMask clear_mask)
| Adjusts the hide/show bits of this particular node.
virtual Light * | as_light ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.
virtual ConstPointerTo< TransformState > | calc_tight_bounds (LPoint3 &min_point, LPoint3 &max_point, bool &found_any, const TransformState *transform, Thread *current_thread=Thread::get_current_thread()) const
| This is used to support NodePath::calc_tight_bounds().
void | clear_attrib (int slot)
| Removes the render attribute of the given type from this node.
void | clear_attrib (TypeHandle type)
void | clear_bounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.
void | clear_effect (TypeHandle type)
| Removes the render effect of the given type from this node.
void | clear_effects (Thread *current_thread=Thread::get_current_thread())
void | clear_state (Thread *current_thread=Thread::get_current_thread())
void | clear_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread())
void | clear_transform (Thread *current_thread=Thread::get_current_thread())
void | clear_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.
virtual PandaNode * | combine_with (PandaNode *other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.
int | compare_tags (const PandaNode *other) const
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.
void | copy_all_properties (PandaNode *other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.
void | copy_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Makes another instance of all the children of the other node, copying them to this node.
PointerTo< PandaNode > | copy_subgraph (Thread *current_thread=Thread::get_current_thread()) const
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
void | copy_tags (PandaNode *other)
| Copies all of the tags stored on the other node onto this node.
int | count_num_descendants () const
| Returns the number of nodes at and below this level.
virtual PandaNode * | dupe_for_flatten () const
| This is similar to make_copy(), but it makes a copy for the specific purpose of flatten.
int | find_child (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | find_parent (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | find_stashed (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
ConstPointerTo< RenderAttrib > | get_attrib (int slot) const
ConstPointerTo< RenderAttrib > | get_attrib (TypeHandle type) const
ConstPointerTo< BoundingVolume > | get_bounds (Thread *current_thread=Thread::get_current_thread()) const
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
ConstPointerTo< BoundingVolume > | get_bounds (UpdateSeq &seq, Thread *current_thread=Thread::get_current_thread()) const
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundingVolume::BoundsType | get_bounds_type () const
PandaNode * | get_child (int n, Thread *current_thread=Thread::get_current_thread()) const
int | get_child_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
Children | get_children (Thread *current_thread=Thread::get_current_thread()) const
DrawMask | get_draw_control_mask () const
DrawMask | get_draw_show_mask () const
ConstPointerTo< RenderEffect > | get_effect (TypeHandle type) const
ConstPointerTo< RenderEffects > | get_effects (Thread *current_thread=Thread::get_current_thread()) const
int | get_fancy_bits (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
virtual int | get_first_visible_child () const
| Returns the index number of the first visible child of this node, or a number >= get_num_children() if there are no visible children of this node.
ConstPointerTo< BoundingVolume > | get_internal_bounds (Thread *current_thread=Thread::get_current_thread()) const
int | get_internal_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_into_collide_mask () const
virtual CollideMask | get_legal_collide_mask () const
int | get_nested_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_net_collide_mask (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.
DrawMask | get_net_draw_control_mask () const
| Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.
DrawMask | get_net_draw_show_mask () const
| Returns the union of all draw_show_mask values–of renderable nodes only– at this level and below.
virtual int | get_next_visible_child (int n) const
| Returns the index number of the next visible child of this node following the indicated child, or a number >= get_num_children() if there are no more visible children of this node.
int | get_num_children (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_parents (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_stashed (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_tags () const
ConstPointerTo< RenderAttrib > | get_off_clip_planes (Thread *current_thread=Thread::get_current_thread()) const
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
PandaNode * | get_parent (int n, Thread *current_thread=Thread::get_current_thread()) const
Parents | get_parents (Thread *current_thread=Thread::get_current_thread()) const
ConstPointerTo< TransformState > | get_prev_transform (Thread *current_thread=Thread::get_current_thread()) const
PandaNode * | get_stashed (int n, Thread *current_thread=Thread::get_current_thread()) const
Stashed | get_stashed (Thread *current_thread=Thread::get_current_thread()) const
int | get_stashed_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
ConstPointerTo< RenderState > | get_state (Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag_key (size_t i) const
void | get_tag_keys (vector_string &keys) const
| Fills the given vector up with the list of tags on this PandaNode.
ConstPointerTo< TransformState > | get_transform (Thread *current_thread=Thread::get_current_thread()) const
unsigned int | get_unexpected_change (unsigned int flags) const
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.
virtual int | get_visible_child () const
| Returns the index number of the currently visible child of this node.
bool | has_attrib (int slot) const
bool | has_attrib (TypeHandle type) const
bool | has_dirty_prev_transform () const
bool | has_effect (TypeHandle type) const
virtual bool | has_selective_visibility () const
| Should be overridden by derived classes to return true if this kind of node has some restrictions on the set of children that should be rendered.
virtual bool | has_single_child_visibility () const
| Should be overridden by derived classes to return true if this kind of node has the special property that just one of its children is visible at any given time, and furthermore that the particular visible child can be determined without reference to any external information (such as a camera).
bool | has_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
bool | has_tags () const
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.
bool | is_bounds_stale () const
virtual bool | is_collision_node () const
| A simple downcast check.
bool | is_final (Thread *current_thread=Thread::get_current_thread()) const
virtual bool | is_geom_node () const
| A simple downcast check.
virtual bool | is_lod_node () const
| A simple downcast check.
bool | is_overall_hidden () const
bool | is_scene_root () const
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.
bool | is_under_scene_root () const
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.
void | list_tags (std::ostream &out, const std::string &separator="\n") const
| Writes a list of all the tag keys assigned to the node to the indicated stream.
void | ls (std::ostream &out, int indent_level) const
void | mark_bounds_stale (Thread *current_thread=Thread::get_current_thread()) const
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
void | mark_internal_bounds_stale (Thread *current_thread=Thread::get_current_thread())
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
void | prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state)
| Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.
virtual bool | preserve_name () const
| Returns true if the node's name has extrinsic meaning and must be preserved across a flatten operation, false otherwise.
void | remove_all_children (Thread *current_thread=Thread::get_current_thread())
| Removes all the children from the node at once, including stashed children.
void | remove_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth child from the node.
bool | remove_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Removes the indicated child from the node.
void | remove_stashed (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth stashed child from the node.
bool | replace_child (PandaNode *orig_child, PandaNode *new_child, Thread *current_thread=Thread::get_current_thread())
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
void | replace_node (PandaNode *other)
| Inserts this node into the scene graph in place of the other one, and removes the other node.
void | reset_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Resets the transform that represents this node's "previous" position to the same as the current transform.
virtual bool | safe_to_combine () const
| Returns true if it is generally safe to combine this particular kind of PandaNode with other kinds of PandaNodes of compatible type, adding children or whatever.
virtual bool | safe_to_combine_children () const
| Returns true if it is generally safe to combine the children of this PandaNode with each other.
virtual bool | safe_to_flatten () const
| Returns true if it is generally safe to flatten out this particular kind of PandaNode by duplicating instances (by calling dupe_for_flatten()), false otherwise (for instance, a Camera cannot be safely flattened, because the Camera pointer itself is meaningful).
virtual bool | safe_to_flatten_below () const
| Returns true if a flatten operation may safely continue past this node, or false if nodes below this node may not be molested.
virtual bool | safe_to_modify_transform () const
| Returns true if it is safe to automatically adjust the transform on this kind of node.
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of PandaNode by calling the xform() method, false otherwise.
void | set_attrib (const RenderAttrib *attrib, int override=0)
| Adds the indicated render attribute to the scene graph on this node.
void | set_bound (const BoundingVolume *volume)
void | set_bounds (const BoundingVolume *volume)
| Resets the bounding volume so that it is the indicated volume.
void | set_bounds_type (BoundingVolume::BoundsType bounds_type)
void | set_effect (const RenderEffect *effect)
| Adds the indicated render effect to the scene graph on this node.
void | set_effects (const RenderEffects *effects, Thread *current_thread=Thread::get_current_thread())
void | set_final (bool flag)
void | set_into_collide_mask (CollideMask mask)
void | set_overall_hidden (bool overall_hidden)
void | set_prev_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
void | set_state (const RenderState *state, Thread *current_thread=Thread::get_current_thread())
void | set_tag (const std::string &key, const std::string &value, Thread *current_thread=Thread::get_current_thread())
void | set_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
void | set_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.
void | stash_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
bool | stash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
void | steal_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Moves all the children from the other node onto this node.
void | unstash_child (int stashed_index, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
bool | unstash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
void | write_recorder (BamWriter *manager, Datagram &dg)
| This method is provided for the benefit of classes (like MouseRecorder) that inherit from PandaMode and also RecorderBase.
virtual void | xform (const LMatrix4 &mat)
| Transforms the contents of this PandaNode by the indicated matrix, if it means anything to do so.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)
Public Member Functions inherited from TextEncoder
| TextEncoder (const TextEncoder &copy)
void | append_text (const std::string &text)
| Appends the indicates string to the end of the stored text.
void | append_unicode_char (char32_t character)
| Appends a single character to the end of the stored text.
void | append_wtext (const std::wstring &text)
| Appends the indicates string to the end of the stored wide-character text.
void | clear_text ()
| Removes the text from the TextEncoder.
std::wstring | decode_text (const std::string &text) const
| Returns the given wstring decoded to a single-byte string, via the current encoding system.
std::string | encode_wtext (const std::wstring &wtext) const
| Encodes a wide-text string into a single-char string, according to the current encoding.
std::string | get_encoded_char (size_t index) const
| Returns the nth char of the stored text, as a one-, two-, or three-byte encoded string.
std::string | get_encoded_char (size_t index, Encoding encoding) const
| Returns the nth char of the stored text, as a one-, two-, or three-byte encoded string.
Encoding | get_encoding () const
| Returns the encoding by which the string set via set_text() is to be interpreted.
size_t | get_num_chars () const
| Returns the number of characters in the stored text.
std::string | get_text () const
std::string | get_text (Encoding encoding) const
std::string | get_text_as_ascii () const
| Returns the text associated with the node, converted as nearly as possible to a fully-ASCII representation.
int | get_unicode_char (size_t index) const
| Returns the Unicode value of the nth character in the stored text.
const std::wstring & | get_wtext () const
| Returns the text associated with the TextEncoder, as a wide-character string.
std::wstring | get_wtext_as_ascii () const
| Returns the text associated with the node, converted as nearly as possible to a fully-ASCII representation.
bool | has_text () const
bool | is_wtext () const
| Returns true if any of the characters in the string returned by get_wtext() are out of the range of an ASCII character (and, therefore, get_wtext() should be called in preference to get_text()).
void | make_lower ()
| Adjusts the text stored within the encoder to all lowercase letters (preserving accent marks correctly).
void | make_upper ()
| Adjusts the text stored within the encoder to all uppercase letters (preserving accent marks correctly).
void | set_encoding (Encoding encoding)
| Specifies how the string set via set_text() is to be interpreted.
void | set_text (const std::string &text)
void | set_text (const std::string &text, Encoding encoding)
void | set_unicode_char (size_t index, char32_t character)
| Sets the Unicode value of the nth character in the stored text.
void | set_wtext (const std::wstring &wtext)
| Changes the text that is stored in the encoder.
Public Member Functions inherited from TextProperties
| TextProperties (const TextProperties &copy)
void | add_properties (const TextProperties &other)
| Sets any properties that are explicitly specified in other on this object.
void | clear ()
| Unsets all properties that have been specified so far, and resets the TextProperties structure to its initial empty state.
void | clear_align ()
void | clear_bin ()
void | clear_direction ()
void | clear_draw_order ()
void | clear_font ()
void | clear_glyph_scale ()
void | clear_glyph_shift ()
void | clear_indent ()
void | clear_preserve_trailing_whitespace ()
void | clear_shadow ()
void | clear_shadow_color ()
void | clear_slant ()
void | clear_small_caps ()
void | clear_small_caps_scale ()
void | clear_tab_width ()
void | clear_text_color ()
void | clear_text_scale ()
void | clear_underscore ()
void | clear_underscore_height ()
void | clear_wordwrap ()
Alignment | get_align () const
const std::string & | get_bin () const
Direction | get_direction () const
int | get_draw_order () const
TextFont * | get_font () const
PN_stdfloat | get_glyph_scale () const
PN_stdfloat | get_glyph_shift () const
PN_stdfloat | get_indent () const
bool | get_preserve_trailing_whitespace () const
LVector2 | get_shadow () const
LColor | get_shadow_color () const
const RenderState * | get_shadow_state () const
| Returns a RenderState object suitable for rendering the shadow of this text with these properties.
PN_stdfloat | get_slant () const
bool | get_small_caps () const
PN_stdfloat | get_small_caps_scale () const
PN_stdfloat | get_tab_width () const
LColor | get_text_color () const
PN_stdfloat | get_text_scale () const
const RenderState * | get_text_state () const
| Returns a RenderState object suitable for rendering text with these properties.
bool | get_underscore () const
PN_stdfloat | get_underscore_height () const
PN_stdfloat | get_wordwrap () const
bool | has_align () const
bool | has_bin () const
bool | has_direction () const
bool | has_draw_order () const
bool | has_font () const
bool | has_glyph_scale () const
bool | has_glyph_shift () const
bool | has_indent () const
bool | has_preserve_trailing_whitespace () const
bool | has_shadow () const
bool | has_shadow_color () const
bool | has_slant () const
bool | has_small_caps () const
bool | has_small_caps_scale () const
bool | has_tab_width () const
bool | has_text_color () const
bool | has_text_scale () const
bool | has_underscore () const
bool | has_underscore_height () const
bool | has_wordwrap () const
bool | is_any_specified () const
| Returns true if any properties have been specified, false otherwise.
bool | operator!= (const TextProperties &other) const
void | operator= (const TextProperties &copy)
bool | operator== (const TextProperties &other) const
void | set_align (Alignment align_type)
void | set_bin (const std::string &bin)
void | set_direction (Direction direction)
int | set_draw_order (int draw_order)
void | set_font (TextFont *font)
void | set_glyph_scale (PN_stdfloat glyph_scale)
void | set_glyph_shift (PN_stdfloat glyph_shift)
void | set_indent (PN_stdfloat indent)
void | set_preserve_trailing_whitespace (bool preserve_trailing_whitespace)
void | set_shadow (const LVecBase2 &shadow_offset)
void | set_shadow (PN_stdfloat xoffset, PN_stdfloat yoffset)
void | set_shadow_color (const LColor &shadow_color)
void | set_shadow_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_slant (PN_stdfloat slant)
void | set_small_caps (bool small_caps)
void | set_small_caps_scale (PN_stdfloat small_caps_scale)
void | set_tab_width (PN_stdfloat tab_width)
void | set_text_color (const LColor &text_color)
void | set_text_color (PN_stdfloat r, PN_stdfloat g, PN_stdfloat b, PN_stdfloat a)
void | set_text_scale (PN_stdfloat text_scale)
void | set_underscore (bool underscore)
void | set_underscore_height (PN_stdfloat underscore_height)
void | set_wordwrap (PN_stdfloat wordwrap)
void | write (std::ostream &out, int indent_level=0) const

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TextNode
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PandaNode
static PointerTo< PandaNode > | decode_from_bam_stream (vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on those bytes.
static DrawMask | get_all_camera_mask ()
static TypeHandle | get_class_type ()
static DrawMask | get_overall_bit ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type PandaNode.
static void | reset_all_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Visits all nodes in the world with the _dirty_prev_transform flag–that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0–and resets the _prev_transform to be the same as _transform.
static void | set_scene_root_func (SceneRootFunc *func)
| This is used by the GraphicsEngine to hook in a pointer to the scene_root_func(), the function to determine whether the node is an active scene root.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TextEncoder
static std::wstring | decode_text (const std::string &text, Encoding encoding)
| Returns the given wstring decoded to a single-byte string, via the given encoding system.
static std::string | encode_wchar (char32_t ch, Encoding encoding)
| Encodes a single Unicode character into a one-, two-, three-, or four-byte string, according to the given encoding system.
static std::string | encode_wtext (const std::wstring &wtext, Encoding encoding)
| Encodes a wide-text string into a single-char string, according to the given encoding.
static Encoding | get_default_encoding ()
static std::string | lower (const std::string &source)
| Converts the string to lowercase, assuming the string is encoded in the default encoding.
static std::string | lower (const std::string &source, Encoding encoding)
| Converts the string to lowercase, assuming the string is encoded in the indicated encoding.
static std::string | reencode_text (const std::string &text, Encoding from, Encoding to)
| Given the indicated text string, which is assumed to be encoded via the encoding "from", decodes it and then reencodes it into the encoding "to", and returns the newly encoded string.
static void | set_default_encoding (Encoding encoding)
static bool | unicode_isalpha (char32_t character)
| Returns true if the indicated character is an alphabetic letter, false otherwise.
static bool | unicode_isdigit (char32_t character)
| Returns true if the indicated character is a numeric digit, false otherwise.
static bool | unicode_islower (char32_t character)
| Returns true if the indicated character is a lowercase letter, false otherwise.
static bool | unicode_ispunct (char32_t character)
| Returns true if the indicated character is a punctuation mark, false otherwise.
static bool | unicode_isspace (char32_t character)
| Returns true if the indicated character is a whitespace letter, false otherwise.
static bool | unicode_isupper (char32_t character)
| Returns true if the indicated character is an uppercase letter, false otherwise.
static int | unicode_tolower (char32_t character)
| Returns the uppercase equivalent of the given Unicode character.
static int | unicode_toupper (char32_t character)
| Returns the uppercase equivalent of the given Unicode character.
static std::string | upper (const std::string &source)
| Converts the string to uppercase, assuming the string is encoded in the default encoding.
static std::string | upper (const std::string &source, Encoding encoding)
| Converts the string to uppercase, assuming the string is encoded in the indicated encoding.
Static Public Member Functions inherited from TextProperties
static TypeHandle | get_class_type ()
static TextFont * | get_default_font ()
| Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.
static void | init_type ()
static void | set_default_font (TextFont *)
| Specifies the default font to be used for any TextNode whose font is uninitialized or NULL.

## Additional Inherited Members
Public Types inherited from TextNode
enum | FlattenFlags { FF_none = 0x0000 , FF_light = 0x0001 , FF_medium = 0x0002 , FF_strong = 0x0004 , FF_dynamic_merge = 0x0008 }
Public Types inherited from PandaNode
enum | FancyBits { FB_transform = 0x0001 , FB_state = 0x0002 , FB_effects = 0x0004 , FB_tag = 0x0010 , FB_draw_mask = 0x0020 , FB_cull_callback = 0x0040 }
typedef bool | SceneRootFunc(const PandaNode *)
enum | UnexpectedChange { UC_parents = 0x001 , UC_children = 0x002 , UC_transform = 0x004 , UC_state = 0x008 , UC_draw_mask = 0x010 }
Public Types inherited from TextEncoder
enum | Encoding { E_iso8859 , E_utf8 , E_utf16be , E_unicode = E_utf16be }
Public Types inherited from TextProperties
enum | Alignment { A_left , A_right , A_center , A_boxed_left , A_boxed_right , A_boxed_center }
enum | Direction { D_ltr , D_rtl }
Public Attributes inherited from TextNode
| clear_align
| clear_bin
| Removes the effect of a previous call to set_bin().
| clear_draw_order
| clear_font
| Resets the font to the default font.
| clear_glyph_scale
| clear_glyph_shift
| clear_indent
| clear_preserve_trailing_whitespace
| clear_shadow
| Specifies that a shadow will not be drawn behind the text.
| clear_shadow_color
| clear_slant
| clear_small_caps
| clear_small_caps_scale
| clear_tab_width
| clear_text_color
| Removes the text color specification; the text will be colored whatever it was in the source font file.
| clear_text_scale
| clear_underscore
| clear_underscore_height
| clear_wordwrap
| Removes the wordwrap setting from the TextNode.
virtual LPoint3 bool const TransformState Thread *current_thread | const
virtual LPoint3 bool & | found_any
| get_align
| get_bin
| get_card_color
| get_card_texture
| get_coordinate_system
| get_draw_order
| get_flatten_flags
| Returns the flatten flags.
| get_font
| get_frame_color
| get_frame_corners
| get_frame_line_width
| Returns the thickness of the lines that will be used to draw the frame.
| get_glyph_scale
| get_glyph_shift
| get_indent
| get_max_rows
| Returns the limit on the height of the TextNode specified by set_max_rows().
| get_preserve_trailing_whitespace
| get_shadow
| get_shadow_color
| get_slant
| get_small_caps
| get_small_caps_scale
| get_tab_width
| get_text_color
| get_text_scale
| get_transform
| get_underscore
| get_underscore_height
| get_usage_hint
| Returns the UsageHint that will be applied to generated geometry.
| get_wordwrap
| has_align
| has_bin
| has_draw_order
| has_font
| has_glyph_scale
| has_glyph_shift
| has_indent
| has_preserve_trailing_whitespace
| has_shadow
| has_shadow_color
| has_slant
| has_small_caps
| has_small_caps_scale
| has_tab_width
| has_text_color
| has_text_scale
| has_underscore
| has_underscore_height
| has_wordwrap
virtual LPoint3 & | max_point
| set_align
| set_bin
| Names the GeomBin that the TextNode geometry should be assigned to.
| set_card_color
| set_card_texture
| set_coordinate_system
| Specifies the coordinate system in which the text will be generated.
| set_draw_order
| Sets the drawing order of text created by the TextMaker.
| set_flatten_flags
| Sets the flatten flags.
| set_font
| Sets the font that will be used when making text.
| set_frame_color
| set_frame_corners
| Enables or disables the drawing of corners for the frame.
| set_frame_line_width
| Specifies the thickness of the lines that will be used to draw the frame.
| set_glyph_scale
| Specifies the factor by which to scale each letter of the text as it is placed.
| set_glyph_shift
| Specifies a vertical amount to shift each letter of the text as it is placed.
| set_indent
| Specifies the amount of extra space that is inserted before the first character of each line.
| set_max_rows
| Sets the maximum number of rows that may be formatted by the TextNode.
| set_preserve_trailing_whitespace
| set_shadow
| Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.
| set_shadow_color
| set_slant
| set_small_caps
| Sets the small_caps flag.
| set_small_caps_scale
| Sets the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.
| set_tab_width
| Sets the width of each tab stop, in screen units.
| set_text_color
| Sets the color of the text.
| set_text_scale
| set_transform
| Sets an additional transform that is applied to the entire text paragraph.
| set_underscore
| set_underscore_height
| set_usage_hint
| Specifies the UsageHint that will be applied to generated geometry.
| set_wordwrap
| Sets the text up to automatically wordwrap when it exceeds the indicated width.
virtual LPoint3 bool const TransformState * | transform
Public Attributes inherited from PandaNode
| clear_tag
| Removes the value defined for this key on this particular node.
| get_all_camera_mask
| Returns a DrawMask that is appropriate for rendering to all cameras.
| get_bounds_type
| Returns the bounding volume type set with set_bounds_type().
| get_child
| Returns the nth child node of this node.
| get_children
| Returns an object that can be used to walk through the list of children of the node.
| get_draw_control_mask
| Returns the set of bits in draw_show_mask that are considered meaningful.
| get_draw_show_mask
| Returns the hide/show bits of this particular node.
| get_effects
| get_internal_bounds
| Returns the node's internal bounding volume.
| get_internal_vertices
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
| get_into_collide_mask
| Returns the "into" collide mask for this node.
| get_legal_collide_mask
| Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.
| get_nested_vertices
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
| get_num_children
| Returns the number of child nodes this node has.
| get_num_parents
| Returns the number of parent nodes this node has.
| get_num_stashed
| Returns the number of stashed nodes this node has.
| get_num_tags
| get_overall_bit
| get_parent
| Returns the nth parent node of this node.
| get_parents
| Returns an object that can be used to walk through the list of parents of the node, similar to get_children() and get_stashed().
| get_prev_transform
| get_python_tags
| get_stashed
| Returns the nth stashed child of this node.
| get_state
| get_tag
| get_tag_key
| get_transform
| has_tag
| is_bounds_stale
| is_final
| Returns the current state of the "final" flag.
| is_overall_hidden
| Returns true if the node has been hidden to all cameras by clearing its overall bit.
| set_bounds_type
| Specifies the desired type of bounding volume that will be created for this node.
| set_effects
| Sets the complete RenderEffects that will be applied this node.
| set_final
| set_into_collide_mask
| Sets the "into" CollideMask.
| set_overall_hidden
| Sets or clears the hidden flag.
| set_state
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| set_tag
| Associates a user-defined value with a user-defined key which is stored on the node.
| set_transform
| Sets the transform that will be applied to this node and below.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name
Public Attributes inherited from TextEncoder
| get_default_encoding
| Specifies the default encoding to be used for all subsequently created TextEncoder objects.
| get_text
| Returns the current text, as encoded via the current encoding system.
| set_default_encoding
| Specifies the default encoding to be used for all subsequently created TextEncoder objects.
| set_text
| Changes the text that is stored in the encoder.
Public Attributes inherited from TextProperties
| clear_align
| Restores the default alignment of the text.
| clear_bin
| Removes the effect of a previous call to set_bin().
| clear_direction
| Clears the text direction setting.
| clear_draw_order
| clear_font
| Restores the default font to the text.
| clear_glyph_scale
| clear_glyph_shift
| clear_indent
| Removes the indent setting from the text.
| clear_preserve_trailing_whitespace
| clear_shadow
| Specifies that a shadow will not be drawn behind the text.
| clear_shadow_color
| Removes the shadow color specification.
| clear_slant
| clear_small_caps
| clear_small_caps_scale
| clear_tab_width
| clear_text_color
| Removes the text color specification; the text will be colored whatever it was in the source font file.
| clear_text_scale
| clear_underscore
| clear_underscore_height
| clear_wordwrap
| Removes the wordwrap setting from the text.
| get_align
| get_bin
| Returns the drawing bin set with set_bin(), or empty string if no bin has been set.
| get_direction
| Returns the direction of the text as specified by set_direction().
| get_draw_order
| Returns the drawing order set with set_draw_order().
| get_font
| Returns the font currently in use, if any.
| get_glyph_scale
| Returns the scale factor of each letter as specified by set_glyph_scale().
| get_glyph_shift
| Returns the vertical shift of each letter as specified by set_glyph_shift().
| get_indent
| get_preserve_trailing_whitespace
| Returns the preserve_trailing_whitespace flag.
| get_shadow
| Returns the offset of the shadow as set by set_shadow().
| get_shadow_color
| get_slant
| Returns the factor by which the text is specified to slant to the right.
| get_small_caps
| Returns the small_caps flag.
| get_small_caps_scale
| Returns the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.
| get_tab_width
| Returns the width set via set_tab_width().
| get_text_color
| get_text_scale
| Returns the scale factor of the text as specified by set_text_scale().
| get_underscore
| Returns the underscore flag.
| get_underscore_height
| Returns the vertical height of the underscore; see set_underscore_height().
| get_wordwrap
| has_align
| has_bin
| Returns true if an explicit drawing bin has been set via set_bin(), false otherwise.
| has_direction
| has_draw_order
| has_font
| has_glyph_scale
| has_glyph_shift
| has_indent
| has_preserve_trailing_whitespace
| has_shadow
| has_shadow_color
| has_slant
| has_small_caps
| has_small_caps_scale
| has_tab_width
| has_text_color
| Returns true if a text color was specified with set_text_color().
| has_text_scale
| has_underscore
| has_underscore_height
| has_wordwrap
| set_align
| Specifies the alignment of the text within its margins.
| set_bin
| Names the CullBin that the text geometry should be assigned to.
| set_direction
| Specifies the text direction.
| set_draw_order
| Sets the drawing order of text created by the TextNode.
| set_font
| Sets the font that will be used when making text.
| set_glyph_scale
| Specifies the factor by which to scale each letter of the text as it is placed, in addition to any scales inherited from the node or from set_text_scale().
| set_glyph_shift
| Specifies a vertical amount to shift each letter of the text as it is placed.
| set_indent
| Specifies the amount of extra space that is inserted before the first character of each line.
| set_preserve_trailing_whitespace
| Sets the preserve_trailing_whitespace flag.
| set_shadow
| Specifies that the text should be drawn with a shadow, by creating a second copy of the text and offsetting it slightly behind the first.
| set_shadow_color
| set_slant
| Specifies the factor by which the text slants to the right.
| set_small_caps
| Sets the small_caps flag.
| set_small_caps_scale
| Sets the scale factor applied to lowercase letters from their uppercase equivalents, when the small_caps flag is in effect.
| set_tab_width
| Sets the width of each tab stop, in screen units.
| set_text_color
| Sets the color of the text.
| set_text_scale
| Specifies the factor by which to scale the text, in addition to any scalings imposed by the node, as well as in addition to the glyph scale.
| set_underscore
| Sets the underscore flag.
| set_underscore_height
| Specifies the vertical height of the underscore, relative to the text baseline.
| set_wordwrap
| Sets the text up to automatically wordwrap when it exceeds the indicated width.
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is a special TextNode that automatically updates itself with output from a SceneGraphAnalyzer instance.

It can be placed anywhere in the world where you'd like to see the output from SceneGraphAnalyzer.

It also has a special mode in which it may be attached directly to a channel or window. If this is done, it creates a DisplayRegion for itself and renders itself in the upper-right-hand corner.

Definition at line 39 of file sceneGraphAnalyzerMeter.h.

## Constructor & Destructor Documentation

## ◆ SceneGraphAnalyzerMeter()

SceneGraphAnalyzerMeter::SceneGraphAnalyzerMeter | ( | const std::string & | name,
|  | PandaNode * | node )
| explicit

Definition at line 32 of file sceneGraphAnalyzerMeter.cxx.

## ◆ ~SceneGraphAnalyzerMeter()

SceneGraphAnalyzerMeter::~SceneGraphAnalyzerMeter | ( |  | ) |
| virtual

Definition at line 63 of file sceneGraphAnalyzerMeter.cxx.

## Member Function Documentation

## ◆ clear_window()

void SceneGraphAnalyzerMeter::clear_window | ( |  | ) |

Undoes the effect of a previous call to setup_window().

Definition at line 120 of file sceneGraphAnalyzerMeter.cxx.

Referenced by setup_window().

## ◆ force_init_type()

virtual TypeHandle SceneGraphAnalyzerMeter::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TextNode.

Definition at line 92 of file sceneGraphAnalyzerMeter.h.

## ◆ get_class_type()

static TypeHandle SceneGraphAnalyzerMeter::get_class_type | ( |  | ) |
| inline static

Definition at line 81 of file sceneGraphAnalyzerMeter.h.

## ◆ get_display_region()

DisplayRegion * SceneGraphAnalyzerMeter::get_display_region | ( |  | ) | const
| inline

Returns the DisplayRegion that the meter has created to render itself into the window to setup_window(), or NULL if setup_window() has not been called.

Definition at line 28 of file sceneGraphAnalyzerMeter.I.

## ◆ get_node()

PandaNode * SceneGraphAnalyzerMeter::get_node | ( |  | ) | const
| inline

Returns the node to be analyzed.

Definition at line 64 of file sceneGraphAnalyzerMeter.I.

## ◆ get_type()

virtual TypeHandle SceneGraphAnalyzerMeter::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TextNode.

Definition at line 89 of file sceneGraphAnalyzerMeter.h.

## ◆ get_update_interval()

double SceneGraphAnalyzerMeter::get_update_interval | ( |  | ) | const
| inline

Returns the number of seconds that will elapse between updates to the frame rate indication.

Definition at line 48 of file sceneGraphAnalyzerMeter.I.

## ◆ get_window()

GraphicsOutput * SceneGraphAnalyzerMeter::get_window | ( |  | ) | const
| inline

Returns the GraphicsOutput that was passed to setup_window(), or NULL if setup_window() has not been called.

Definition at line 18 of file sceneGraphAnalyzerMeter.I.

## ◆ init_type()

static void SceneGraphAnalyzerMeter::init_type | ( |  | ) |
| inline static

Definition at line 84 of file sceneGraphAnalyzerMeter.h.

## ◆ set_node()

void SceneGraphAnalyzerMeter::set_node | ( | PandaNode * | node | ) |
| inline

Sets the node to be analyzed.

Definition at line 56 of file sceneGraphAnalyzerMeter.I.

## ◆ set_update_interval()

void SceneGraphAnalyzerMeter::set_update_interval | ( | double | update_interval | ) |
| inline

Specifies the number of seconds that should elapse between updates to the meter.

This should be reasonably slow (e.g. 0.5 to 2.0) so that the calculation of the scene graph analysis does not itself dominate the frame rate.

Definition at line 39 of file sceneGraphAnalyzerMeter.I.

## ◆ setup_window()

void SceneGraphAnalyzerMeter::setup_window | ( | GraphicsOutput * | window | ) |

Sets up the frame rate meter to create a DisplayRegion to render itself into the indicated window.

Definition at line 72 of file sceneGraphAnalyzerMeter.cxx.

References clear_window(), DepthTestAttrib::make(), DepthWriteAttrib::make(), and Lens::set_film_size.

## ◆ update()

void SceneGraphAnalyzerMeter::update | ( |  | ) |
| inline

You can call this to explicitly force the SceneGraphAnalyzerMeter to update itself with the latest scene graph analysis information.

Normally, it is not necessary to call this explicitly.

Definition at line 74 of file sceneGraphAnalyzerMeter.I.

References Thread::get_current_thread.

The documentation for this class was generated from the following files:

- panda/src/grutil/sceneGraphAnalyzerMeter.h
- panda/src/grutil/sceneGraphAnalyzerMeter.cxx
- panda/src/grutil/sceneGraphAnalyzerMeter.I